import { __read } from "tslib";
import { parseRadius } from '../../utils/parse';
export function generatePath(context, parsedStyle) {
  var radius = parsedStyle.radius,
      width = parsedStyle.width,
      height = parsedStyle.height;
  var w = width.value;
  var h = height.value;
  var r = radius && radius.value || 0;

  if (r === 0) {
    context.rect(0, 0, w, h);
  } else {
    var _a = __read(parseRadius(r), 4),
        r1 = _a[0],
        r2 = _a[1],
        r3 = _a[2],
        r4 = _a[3];

    context.moveTo(r1, 0);
    context.lineTo(w - r2, 0);

    if (r2 !== 0) {
      context.arc(w - r2, r2, r2, -Math.PI / 2, 0);
    }

    context.lineTo(w, h - r3);

    if (r3 !== 0) {
      context.arc(w - r3, h - r3, r3, 0, Math.PI / 2);
    }

    context.lineTo(r4, h);

    if (r4 !== 0) {
      context.arc(r4, h - r4, r4, Math.PI / 2, Math.PI);
    }

    context.lineTo(0, r1);

    if (r1 !== 0) {
      context.arc(r1, r1, r1, Math.PI, Math.PI * 1.5);
    }
  }
}