import type { RenderingService, RenderingPlugin } from '@antv/g';
export declare const RBushRoot = "RBushRoot";
/**
 * support 2 modes in rendering:
 * * immediate
 * * delayed: render at the end of frame with dirty-rectangle
 */
export declare class CanvasRendererPlugin implements RenderingPlugin {
    static tag: string;
    private canvasConfig;
    private camera;
    private contextService;
    private renderingContext;
    private imagePool;
    private gradientPool;
    private pathGeneratorFactory;
    private styleRendererFactory;
    private displayObjectPool;
    /**
     * RBush used in dirty rectangle rendering
     */
    private rBush;
    private removedRBushNodeAABBs;
    private renderQueue;
    private restoreStack;
    private clearFullScreen;
    private enableBatch;
    private batchedStyleHash;
    private batchedDisplayObject;
    private syncRTree;
    /**
     * sync to RBush later
     */
    private toSync;
    private pushToSync;
    apply(renderingService: RenderingService): void;
    private flush;
    private renderDisplayObject;
    private convertAABB2Rect;
    /**
     * TODO: merge dirty rectangles with some strategies.
     * For now, we just simply merge all the rectangles into one.
     * @see https://idom.me/articles/841.html
     */
    private mergeDirtyAABBs;
    private searchDirtyObjects;
    private saveDirtyAABB;
    private applyTransform;
    private getColor;
    private applyAttributesToContext;
    private useAnchor;
    private safeMergeAABB;
}
