"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generatePath = generatePath;

function generatePath(context, parsedStyle) {
  var rxInPixels = parsedStyle.rx,
      ryInPixels = parsedStyle.ry;
  var rx = rxInPixels.value;
  var ry = ryInPixels.value; // @see https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/ellipse

  if (context.ellipse) {
    context.ellipse(rx, ry, rx, ry, 0, 0, Math.PI * 2, false);
  } else {
    // 如果不支持，则使用圆来绘制，进行变形
    var r = rx > ry ? rx : ry;
    var scaleX = rx > ry ? 1 : rx / ry;
    var scaleY = rx > ry ? ry / rx : 1;
    context.save();
    context.scale(scaleX, scaleY);
    context.arc(0, 0, r, 0, Math.PI * 2);
  }
}