"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "CirclePath", {
  enumerable: true,
  get: function get() {
    return _Circle.generatePath;
  }
});
Object.defineProperty(exports, "EllipsePath", {
  enumerable: true,
  get: function get() {
    return _Ellipse.generatePath;
  }
});
Object.defineProperty(exports, "LinePath", {
  enumerable: true,
  get: function get() {
    return _Line.generatePath;
  }
});
exports.PathGeneratorFactory = exports.PathGenerator = void 0;
Object.defineProperty(exports, "PathPath", {
  enumerable: true,
  get: function get() {
    return _Path.generatePath;
  }
});
Object.defineProperty(exports, "PolygonPath", {
  enumerable: true,
  get: function get() {
    return _Polygon.generatePath;
  }
});
Object.defineProperty(exports, "PolylinePath", {
  enumerable: true,
  get: function get() {
    return _Polyline.generatePath;
  }
});
Object.defineProperty(exports, "RectPath", {
  enumerable: true,
  get: function get() {
    return _Rect.generatePath;
  }
});

var _manaSyringe = require("mana-syringe");

var _Circle = require("./Circle");

var _Ellipse = require("./Ellipse");

var _Rect = require("./Rect");

var _Line = require("./Line");

var _Polyline = require("./Polyline");

var _Polygon = require("./Polygon");

var _Path = require("./Path");

var PathGeneratorFactory = _manaSyringe.Syringe.defineToken('PathGeneratorFactory');

exports.PathGeneratorFactory = PathGeneratorFactory;

var PathGenerator = _manaSyringe.Syringe.defineToken('PathGenerator');

exports.PathGenerator = PathGenerator;