"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ImageRenderer = void 0;

var _tslib = require("tslib");

var _g = require("@antv/g");

var _manaSyringe = require("mana-syringe");

var _ImagePool = require("../ImagePool");

var _interfaces = require("./interfaces");

var ImageRenderer =
/** @class */
function () {
  function ImageRenderer() {}

  ImageRenderer.prototype.hash = function (parsedStyle) {
    return '';
  };

  ImageRenderer.prototype.render = function (context, parsedStyle) {
    var width = parsedStyle.width,
        height = parsedStyle.height,
        img = parsedStyle.img;
    var image;
    var iw = width.value;
    var ih = height.value;

    if ((0, _g.isString)(img)) {
      // image has been loaded in `mounted` hook
      image = this.imagePool.getImageSync(img);
    } else {
      iw || (iw = img.width);
      ih || (ih = img.height);
      image = img;
    }

    if (image) {
      context.drawImage(image, 0, 0, iw, ih);
    }
  };

  (0, _tslib.__decorate)([(0, _manaSyringe.inject)(_ImagePool.ImagePool), (0, _tslib.__metadata)("design:type", _ImagePool.ImagePool)], ImageRenderer.prototype, "imagePool", void 0);
  ImageRenderer = (0, _tslib.__decorate)([(0, _manaSyringe.singleton)({
    token: _interfaces.ImageRendererContribution
  })], ImageRenderer);
  return ImageRenderer;
}();

exports.ImageRenderer = ImageRenderer;